      SUBROUTINE UMAT(STRESS,STATEV,DDSDDE,SSE,SPD,SCD,
     1 RPL,DDSDDT,DRPLDE,DRPLDT,STRAN,DSTRAN,
     2 TIME,DTIME,TEMP,DTEMP,PREDEF,DPRED,MATERL,NDI,NSHR,NTENS,
     3 NSTATV,PROPS,NPROPS,COORDS,DROT,PNEWDT,CELENT,
     4 DFGRD0,DFGRD1,NOEL,NPT,KSLAY,KSPT,KSTEP,KINC)


      INCLUDE 'ABA_PARAM.INC'

      DIMENSION STRESS(NTENS),STATEV(NSTATV),
     1 DDSDDE(NTENS,NTENS),DDSDDT(NTENS),DRPLDE(NTENS),
     2 STRAN(NTENS),DSTRAN(NTENS),TIME(2),PREDEF(1),DPRED(1),
     3 PROPS(NPROPS),COORDS(3),DROT(3,3),
     4 DFGRD0(3,3),DFGRD1(3,3)

      PARAMETER (ONE=1.0D0,TWO=2.0D0,THREE=3.0D0,SIX=6.0D0)
      DATA NEWTON,TOLER/10,1.D-6/

c     Appel fonction C fonction du nom du materiau
      CHARACTER(LEN=80) MATERL

c---------------------------------------------
c     declaration appelc pour chaque materiau
c---------------------------------------------
      CHARACTER*80 NOM_MAT_TMP
c     appelc materiau : H_THERMO
      EXTERNAL appelc_1


      IF (NDI.NE.3) THEN
        WRITE(6,1)
 1      FORMAT(//,30X,'***ERROR - THIS UMAT MAY ONLY BE USED FOR ',
     1       'ELEMENTS WITH THREE DIRECT STRESS COMPONENTS')

        CALL XIT
      ENDIF 

c-------------------------------------------------------
c     selection appelc_i en fonction du nom du materiau
c             (rappel : Abaqus fournit le nom en majuscules)
c-------------------------------------------------------
      NB_CHAR = INDEX(MATERL,' ')-1
      NOM_MAT_TMP = MATERL(1:NB_CHAR)

      IF(NPT.EQ.1) THEN
        WRITE(*,*) 'increment : ', KINC
        WRITE(*,*) '   temps initial : ', TIME(2)
        WRITE(*,*) '   pas de temps  : ', DTIME
        WRITE(*,*) '   TC au temps initial : ', TEMP
        WRITE(*,*) '   increment de TC     : ', DTEMP
      ENDIF

cccc  decommenter cette ligne pour envoyer la bonne temperature a herezh
c      TEMP = TEMP + DTEMP

c     materiau : H_THERMO ==> appelc_1
      IF(NOM_MAT_TMP.EQ.'H_THERMO') THEN
      call appelc_1(
     1  %ref(STRESS),
     2  %ref(DDSDDE),
     3  %ref(SSE),
     4  %ref(SPD),
     5  %ref(SCD),
     6  %ref(RPL),
     7  %ref(DDSDDT),
     8  %ref(DRPLDE),
     9  %ref(DRPLDT),
     1  %ref(STRAN),
     2  %ref(DSTRAN),
     3  %ref(TIME),
     4  %ref(DTIME),
     5  %ref(TEMP),
     6  %ref(DTEMP),
     7  %ref(MATERL // char(0)),
     8  %ref(NDI),
     9  %ref(NSHR),
     1  %ref(NTENS),
     2  %ref(NSTATV),
     3  %ref(PROPS),
     4  %ref(NPROPS),
     5  %ref(COORDS),
     6  %ref(DROT),
     7  %ref(PNEWDT),
     8  %ref(CELENT),
     9  %ref(DFGRD0),
     1  %ref(DFGRD1),
     2  %ref(NOEL),
     3  %ref(NPT),
     4  %ref(KSLAY),
     5  %ref(KSPT),
     6  %ref(KSTEP),
     7  %ref(KINC))

c     ecriture message erreur dans le .dat en cas de materiau non reconnu
      ELSE
        WRITE(6,*) 'erreur : materiau inconnu => ', MATERL
        CALL XIT
      ENDIF

      RETURN
      END
