from odbAccess import *
from sys import argv, exit
import re
from subprocess import call
import os
import string


odbName = None



if(len(argv) < 5):
  print
  print 'Erreur : le nombre d arguments est incorrect'
  print '     > 5 arguments obligatoires :'
  print '            1- nom fichier .odb'
  print '            2- numero noeud ou set de noeuds'
  print '            3- nom de la node output variable (moyenne sur le nombre de noeuds)'
  print '            4- nom du fichier incr-temps-(arg 3) a creer'
  print '     > 3 options facultatives :'
  print '            5- -I nom_instance'
  print '            6- -somme (faire la somme plutot que la moyenne)'
  print '            7- -step no_step'
  print
  exit(0)

if(re.search('.odb$', argv[1]) == None):
  print
  print "Erreur : Le 1er argument (%s) n est pas un fichier .odb" % (argv[1])
  print
  exit(0)


type_noeud = "numero"
try:
  int(argv[2])
except:
  type_noeud = "Nset"


#------------
#arguments
#------------

odb = openOdb(argv[1])
#cas d un numero de noeud
if(type_noeud == "numero"):
  label_noeud = int(argv[2])
#cas d un set de noeuds
else:
  label_noeud = argv[2].upper()
output_variable = argv[3].upper()
fic_sortie = argv[4]



#------------
#options
#------------

#choix de l instance (par defaut : la premiere trouvee dans le rootAssembly)
nom_instance = odb.rootAssembly.instances.keys()[0]
ref_instance = odb.rootAssembly.instances[nom_instance]
for i in range(len(argv)):
  if(argv[i] == '-I'):
    try:
      nom_instance = argv[i+1]
    except:
      print
      print 'Erreur option -I : pas assez d arguments (nom de l instance non specifie)...'
      print
      exit(0)
    try:
      nom_instance = nom_instance.upper()
      ref_instance = odb.rootAssembly.instances[nom_instance]
    except:
      print
      print 'Erreur option -I : instance (%s) n existe pas dans le fichier (%s)...' % (nom_instance,argv[1])
      print
      exit(0)
    break
#verif du noeud ou set de noeuds dans l instance choisie
nb_noeuds_set = 0
ind_tab_noeud = -1
#-cas d un numero de noeud
if(type_noeud == "numero"):
  noeud_ok = False
  for node in ref_instance.nodes:
    if(node.label == label_noeud):
      noeud_ok = True
      break
  if(not noeud_ok):
    print
    print "Erreur : Le noeud (%s) n existe pas dans l instance (%s)" % (label_noeud,nom_instance)
    print
    exit(0)
  nb_noeuds_set = 1
  #on verifie que la output variable soit disponible et on recupere l indice de tableau
  #correspondant au noeud
  try:
    VAR_ok = False
    VAR = odb.steps[odb.steps.values()[0].name].frames[0].fieldOutputs[output_variable].getSubset(region=ref_instance)
    for i in range(len(VAR.values)):
      if(VAR.values[i].nodeLabel == label_noeud):
        VAR_ok = True
        ind_tab_noeud = i
        break
  except:
    print
    print 'Erreur : la variable %s n existe pas pour le numero de noeud %s' % (output_variable,label_noeud)
    print
    exit(0)

  if(not VAR_ok):
    print
    print 'Erreur : la variable %s n existe pas pour le numero de noeud %s' % (output_variable,label_noeud)
    print
    exit(0)

#-cas d un set de noeuds
else:
  try:
    ref_noeuds = ref_instance.nodeSets[label_noeud]
  except:
    print
    print "Erreur : Le set de noeuds (%s) n existe pas dans l instance (%s)" % (label_noeud,nom_instance)
    print
    exit(0)
  nb_noeuds_set = len(ref_noeuds.nodes)
  #on verifie que la output variable soit disponible
  try:
    odb.steps[odb.steps.values()[0].name].frames[0].fieldOutputs[output_variable].getSubset(region=ref_noeuds).values[0]
  except:
    print
    print 'Erreur : la variable %s n existe pas pour le set de noeuds %s' % (output_variable,label_noeud)
    print
    exit(0)


#type de traitement de l output variable (moyenne par defaut, sinon somme si option -somme)
type_traitement = "moyenne"
for i in range(len(argv)):
  if(argv[i] == '-somme'):
    type_traitement = "somme"
    break


#verif de la presence de l option -step
no_step = 0
for i in xrange(len(argv)):
  if(argv[i] == '-step'):
    try:
      no_step = argv[i+1]
    except:
      print
      print "Erreur option -step : pas assez d arguments (numero du step non specifie)..."
      print
      exit(0)
    try:
      no_step = int(no_step)
    except:
      print
      print "Erreur option -step : la valeur specifiee (%s) n est pas un entier..." % no_step
      print
      exit(0)
    break




print
print '------------------------------------------'
print 'prog python                            : %s' % argv[0]
print 'fichier odb                            : %s' % argv[1]
print 'instance                               : %s' % nom_instance
print 'label noeud                            : %s' % label_noeud
print 'output variable                        : %s' % output_variable
print 'type de traitement                     : %s' % type_traitement
print 'fichier sortie                         : %s' % fic_sortie
print
if(no_step == 0):
  print 'steps                                  : %s' % 'TOUS'
else:
  print 'step                                   : %s' % no_step
print '------------------------------------------'
print


'''debut: def convert_inv_name '''
def convert_inv_name(inv_name):
  if(re.search('^MAX_PRINCIPAL$', inv_name) != None):
    return('maxPrincipal')
  if(re.search('^MID_PRINCIPAL$', inv_name) != None):
    return('midPrincipal')
  if(re.search('^MIN_PRINCIPAL$', inv_name) != None):
    return('minPrincipal')
  if(re.search('^TRESCA$', inv_name) != None):
    return('tresca')
  if(re.search('^PRESS$', inv_name) != None):
    return('press')
  if(re.search('^MISES$', inv_name) != None):
    return('mises')
  if(re.search('^INV3$', inv_name) != None):
    return('inv3')
  if(re.search('^MAGNITUDE$', inv_name) != None):
    return('magnitude')

  print
  print 'Erreur : invariant inconnu (%s)' % inv_name
  print
  exit(0)
'''fin: def convert_inv_name'''

#verif de la node output variable
try:
  VAR_INFO = odb.steps[odb.steps.values()[0].name].frames[0].fieldOutputs[output_variable]
  type_var = '%s' % VAR_INFO.type
  nb_scalars = 0
  nb_components = 0
  nb_invariants = 0
  liste_components = []
  liste_invariants = []
  nb_components = len(VAR_INFO.componentLabels)
  nb_invariants = len(VAR_INFO.validInvariants)
  if(re.search('SCALAR', type_var) != None):
    nb_scalars = 1
  else:
    for i in range(nb_components):
      liste_components.append(VAR_INFO.componentLabels[i])
    for i in range(nb_invariants):
      type_inv = '%s' % VAR_INFO.validInvariants[i]
      type_inv = convert_inv_name(type_inv)
      liste_invariants.append(type_inv)
except:
  print
  print "Erreur : output variable (%s) invalide" % output_variable
  print
  exit(0)


 
'''debut: def moyenne_nb_noeuds '''
def moyenne_nb_noeuds(tab_val):
  moyenne = 0.
  for val in tab_val:
    moyenne += val
  moyenne = moyenne/len(tab_val)
  return(moyenne)
'''fin: def moyenne_nb_noeuds '''

'''debut: def somme '''
def somme(liste):
  somme = 0.
  for val in liste:
    somme += val

  return(somme)
'''fin: def somme'''


fic = open(fic_sortie, "w")
fic.write("#fichier odb  : %s\n" % argv[1])
fic.write("#instance     : %s\n" % nom_instance)
if(no_step == 0):
  fic.write("#steps         : %s\n" % 'TOUS')
else:
  fic.write("#step          : %s\n" % no_step)
fic.write("#label noeud  : %s (nombre de noeuds : %d)\n" % (label_noeud,nb_noeuds_set))
fic.write("#variable     : %s (%s sur le nombre de noeuds)\n" % (output_variable,type_traitement))
fic.write("#  numeros colonnes pour gnuplot :\n")
fic.write("#     1- increment\n")
fic.write("#     2- temps\n")
no_col = 2
en_tete = '%16s %16s' % (string.ljust('#increment',16),string.ljust('temps',16))
'''scalars'''
if(nb_scalars == 1):
  no_col += 1
  fic.write("#     %d- %s\n" % (no_col,output_variable))
  en_tete += ' %16s' % string.ljust(output_var,16)
else:
  for i in range(nb_scalars):
    no_col += 1
    fic.write("#     %d- %s-%d\n" % (no_col,output_variable,i))
    tmp = '%s-%d' % (output_variable,i) 
    en_tete += ' %16s' % string.ljust(tmp,16)
'''components'''
for i in range(nb_components):
  no_col += 1
  fic.write("#     %d- %s\n" % (no_col,liste_components[i]))
  en_tete += ' %16s' % string.ljust(liste_components[i],16)
'''invariants'''
for i in range(nb_invariants):
  no_col += 1
  fic.write("#     %d- %s\n" % (no_col,liste_invariants[i]))
  en_tete += ' %16s' % string.ljust(liste_invariants[i],16)
fic.write("\n")
fic.write("%s\n" % en_tete)




'''
extration de la output variable : output_variable
'''
print 'extraction de %s' % output_variable

print '  >nombre de valeurs scalaires : %d' % nb_scalars
print '  >nombre de composantes : %d' % nb_components
for i in range(nb_components):
  print '    >%s' % liste_components[i]
print '  >nombre d invariants : %d' % nb_invariants
for i in range(nb_invariants):
  print '    >%s' % liste_invariants[i]
print


temps_total = 0
increment_total = 0
incr_prec = 0
temps_prec = 0

'''tous les increments de chaque step'''
for nom_step in odb.steps.keys():
  try:
    no_dernier_incr = odb.steps[nom_step].frames[-1].incrementNumber
  except:
    print 'ATTENTION : le step %s est inexploitable...' % nom_step
    continue

  #cas de l option -step (on actualise quand meme increment_total, temps_total, incr_prec et temps_prec avant de sauter le step)
  if((no_step != 0) and (odb.steps[nom_step].number != no_step)):
    temps_prec = 0
    incr_prec = 0
    incr = odb.steps[nom_step].frames[-1]
    increment_total = increment_total + (incr.incrementNumber - incr_prec)
    temps_total = temps_total + (incr.frameValue - temps_prec)
    incr_prec = incr.incrementNumber
    temps_prec = incr.frameValue
    continue

  #on ecrit une ligne blanche avant tous step sauf le premier et sauf dans le cas de l option -step
  if((odb.steps[nom_step].number != 1) and (not ((no_step != 0) and (odb.steps[nom_step].number == no_step)))):
    fic.write("\n")

  for incr in odb.steps[nom_step].frames:
    '''on reinitialise les temps et no increment locaux au step'''
    if(incr.incrementNumber == 0):
      temps_prec = 0
      incr_prec = 0

    print '-step %s increment %d sur %d' % (nom_step,incr.incrementNumber,no_dernier_incr)

    increment_total = increment_total + (incr.incrementNumber - incr_prec)
    temps_total = temps_total + (incr.frameValue - temps_prec)
    incr_tot_string = '%d' % increment_total
    incr_tot_string = string.ljust(incr_tot_string,16)
    tps_tot_string = '%.8f' % temps_total
    tps_tot_string = string.ljust(tps_tot_string,16)
    ligne_a_ecrire  = '%16s %16s' % (incr_tot_string,tps_tot_string)


    '''ajout d une ligne dans le fichier sortie'''
    #cas d un numero de noeud
    if(type_noeud == "numero"):
      VAR = incr.fieldOutputs[output_variable].getSubset(region=ref_instance).values
      '''scalars'''
      for i in range(nb_scalars):
        scal = '%.8f' % VAR[ind_tab_noeud].data
        scal = string.ljust(scal,16)
        ligne_a_ecrire += ' %16s' % scal
      '''components'''
      for i in range(nb_components):
        comp = '%.8f' % VAR[ind_tab_noeud].data[i]
        comp = string.ljust(comp,16)
        ligne_a_ecrire += ' %16s' % comp
      '''invariants'''
      for i in range(nb_invariants):
        inv = '%.8f' % VAR[ind_tab_noeud].__getattribute__(liste_invariants[i])
        inv = string.ljust(inv,16)
        ligne_a_ecrire += ' %16s' % inv
    #cas d un set de noeuds
    else:
      VAR = incr.fieldOutputs[output_variable].getSubset(region=ref_noeuds).values
      '''scalars'''
      for i in range(nb_scalars):
        tab_val = []
        for val in VAR:
          tab_val.append(val.data)
        #cas d une somme (option -somme)
        if(type_traitement == 'somme'):
          scal = '%.8f' % somme(tab_val)
        #cas d une moyenne (mode par defaut)
        else:
          scal = '%.8f' % moyenne_nb_noeuds(tab_val)
        scal = string.ljust(scal,16)
        ligne_a_ecrire += ' %16s' % scal
      '''components'''
      for i in range(nb_components):
        tab_val = []
        for val in VAR:
          tab_val.append(val.data[i])
        #cas d une somme (option -somme)
        if(type_traitement == 'somme'):
          comp = '%.8f' % somme(tab_val)
        #cas d une moyenne (mode par defaut)
        else:
          comp = '%.8f' % moyenne_nb_noeuds(tab_val)
        comp = string.ljust(comp,16)
        ligne_a_ecrire += ' %16s' % comp
      '''invariants'''
      for i in range(nb_invariants):
        tab_val = []
        for val in VAR:
          tab_val.append(val.__getattribute__(liste_invariants[i]))
        #cas d une somme (option -somme)
        if(type_traitement == 'somme'):
          inv = '%.8f' % somme(tab_val)
        #cas d une moyenne (mode par defaut)
        else:
          inv = '%.8f' % moyenne_nb_noeuds(tab_val)
        inv = string.ljust(inv,16)
        ligne_a_ecrire += ' %16s' % inv

    fic.write("%s\n" % ligne_a_ecrire)

    incr_prec = incr.incrementNumber
    temps_prec = incr.frameValue

odb.close()
fic.close()


print '------------------------------------------'
print
